package tools.descartes.dql.core.engine.whatif;

import java.util.Iterator;

import tools.descartes.dql.models.mapping.domain.Resource;
import tools.descartes.dql.models.mapping.domain.Service;
import tools.descartes.dql.models.mapping.mapping.EntityMapping;

public class EntityFilter implements WhatIfFilter {

	private String entityIdentifier;
	
	public EntityFilter(String entityIdentifier) {
		this.entityIdentifier = entityIdentifier;
	}
	
	@Override
	public EntityMapping applyFilter(EntityMapping initial, EntityMapping modified) {
		for (Iterator<Resource> i = modified.getResources().iterator(); i.hasNext();) {
			Resource r = i.next();
			if (!r.getIdentifier().equals(entityIdentifier))
				i.remove();
		}
		for (Iterator<Service> i = modified.getServices().iterator(); i.hasNext();) {
			Service r = i.next();
			if (!r.getIdentifier().equals(entityIdentifier))
				i.remove();
		}
		return modified;
	}
	

}
