package tools.descartes.dql.core.engine.whatif;

import java.util.Iterator;

import tools.descartes.dql.models.mapping.domain.Probe;
import tools.descartes.dql.models.mapping.domain.Resource;
import tools.descartes.dql.models.mapping.domain.Service;
import tools.descartes.dql.models.mapping.mapping.EntityMapping;

public class MetricFilter implements WhatIfFilter {

	private String metricIdentifier;

	public MetricFilter(String metricIdentifier) {
		this.metricIdentifier = metricIdentifier;
	}

	@Override
	public EntityMapping applyFilter(EntityMapping initial, EntityMapping modified) {
		for (Iterator<Resource> i = modified.getResources().iterator(); i.hasNext();) {
			Resource r = i.next();
			for (Iterator<Probe> i2 = r.getProbes().iterator(); i2.hasNext();) {
				Probe probe = i2.next();
				if (!probe.getMetricName().equals(metricIdentifier)) {
					i2.remove();
				}
			}
			if (r.getProbes().isEmpty())
				i.remove();
		}

		for (Iterator<Service> i = modified.getServices().iterator(); i.hasNext();) {
			Service r = i.next();
			for (Iterator<Probe> i2 = r.getProbes().iterator(); i2.hasNext();) {
				Probe probe = i2.next();
				if (!probe.getMetricName().equals(metricIdentifier)) {
					i2.remove();
				}
			}
			if (r.getProbes().isEmpty())
				i.remove();
		}

		return modified;

	}

}
