package tools.descartes.dql.core.engine.whatif;

import java.util.Iterator;

import tools.descartes.dql.models.mapping.domain.DecimalResult;
import tools.descartes.dql.models.mapping.domain.Probe;
import tools.descartes.dql.models.mapping.domain.Resource;
import tools.descartes.dql.models.mapping.domain.Service;
import tools.descartes.dql.models.mapping.mapping.EntityMapping;

public class ZeroFilter implements WhatIfFilter {

	public ZeroFilter() {

	}

	@Override
	public EntityMapping applyFilter(EntityMapping initial, EntityMapping modified) {
		if (!initial.equals(modified)) { // else the initial gets modified and
											// looses all content

			// checking all Resources
			for (Iterator<Resource> resourceIterator = modified.getResources().iterator(); resourceIterator.hasNext();) {
				Resource resource = resourceIterator.next();
				for (Iterator<Probe> probeIterator = resource.getProbes().iterator(); probeIterator.hasNext();) {
					Probe probe = probeIterator.next();
					DecimalResult modifiedResult = (DecimalResult) probe;
					if (modifiedResult.getValue().intValue() == 0)
						probeIterator.remove();
				}
				if (resource.getProbes().isEmpty())
					resourceIterator.remove();
			}

			// checking all Services
			for (Iterator<Service> serviceIterator = modified.getServices().iterator(); serviceIterator.hasNext();) {
				Service service = serviceIterator.next();
				for (Iterator<Probe> probeIteratpr = service.getProbes().iterator(); probeIteratpr.hasNext();) {
					Probe probe = probeIteratpr.next();
					DecimalResult modifiedResult = (DecimalResult) probe;
					if (modifiedResult.getValue().intValue() == 0)
						probeIteratpr.remove();
				}
				if (service.getProbes().isEmpty())
					serviceIterator.remove();
			}

			return modified;
		} else
			return initial;

	}

}
