/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.domain;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dql.models.mapping.domain.DomainFactory
 * @model kind="package"
 * @generated
 */
public interface DomainPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "domain";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/dql/models/mapping/domain/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "domain";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DomainPackage eINSTANCE = tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.EntityImpl <em>Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.EntityImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getEntity()
	 * @generated
	 */
	int ENTITY = 2;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__IDENTIFIER = 0;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__ALIAS = 1;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__PROBES = 2;

	/**
	 * The number of structural features of the '<em>Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResourceImpl <em>Resource</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ResourceImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResource()
	 * @generated
	 */
	int RESOURCE = 0;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__IDENTIFIER = ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__ALIAS = ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__PROBES = ENTITY__PROBES;

	/**
	 * The number of structural features of the '<em>Resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ServiceImpl <em>Service</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ServiceImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getService()
	 * @generated
	 */
	int SERVICE = 1;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__IDENTIFIER = ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__ALIAS = ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__PROBES = ENTITY__PROBES;

	/**
	 * The number of structural features of the '<em>Service</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ProbeImpl <em>Probe</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ProbeImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getProbe()
	 * @generated
	 */
	int PROBE = 3;

	/**
	 * The feature id for the '<em><b>Metric Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBE__METRIC_NAME = 0;

	/**
	 * The number of structural features of the '<em>Probe</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResultImpl <em>Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResult()
	 * @generated
	 */
	int RESULT = 5;

	/**
	 * The feature id for the '<em><b>Metric Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT__METRIC_NAME = PROBE__METRIC_NAME;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT__VALID = PROBE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_FEATURE_COUNT = PROBE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.DecimalResultImpl <em>Decimal Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.DecimalResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDecimalResult()
	 * @generated
	 */
	int DECIMAL_RESULT = 4;

	/**
	 * The feature id for the '<em><b>Metric Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT__METRIC_NAME = RESULT__METRIC_NAME;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT__VALID = RESULT__VALID;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT__VALUE = RESULT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Accuracy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT__ACCURACY = RESULT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Decimal Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT_FEATURE_COUNT = RESULT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ExtendedEntityImpl <em>Extended Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ExtendedEntityImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getExtendedEntity()
	 * @generated
	 */
	int EXTENDED_ENTITY = 8;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY__IDENTIFIER = ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY__ALIAS = ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY__PROBES = ENTITY__PROBES;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY__PROPERTIES = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Extended Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.DoFImpl <em>Do F</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.DoFImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDoF()
	 * @generated
	 */
	int DO_F = 6;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__IDENTIFIER = EXTENDED_ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__ALIAS = EXTENDED_ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__PROBES = EXTENDED_ENTITY__PROBES;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__PROPERTIES = EXTENDED_ENTITY__PROPERTIES;

	/**
	 * The feature id for the '<em><b>Current State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__CURRENT_STATE = EXTENDED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Do F</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F_FEATURE_COUNT = EXTENDED_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.AggregateImpl <em>Aggregate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.AggregateImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getAggregate()
	 * @generated
	 */
	int AGGREGATE = 7;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE__IDENTIFIER = EXTENDED_ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE__ALIAS = EXTENDED_ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE__PROBES = EXTENDED_ENTITY__PROBES;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE__PROPERTIES = EXTENDED_ENTITY__PROPERTIES;

	/**
	 * The number of structural features of the '<em>Aggregate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE_FEATURE_COUNT = EXTENDED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '<em>Properties</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.util.Properties
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getProperties()
	 * @generated
	 */
	int PROPERTIES = 9;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Resource <em>Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resource</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Resource
	 * @generated
	 */
	EClass getResource();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Service <em>Service</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Service
	 * @generated
	 */
	EClass getService();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Entity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Entity
	 * @generated
	 */
	EClass getEntity();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.Entity#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Identifier</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Entity#getIdentifier()
	 * @see #getEntity()
	 * @generated
	 */
	EAttribute getEntity_Identifier();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.Entity#getAlias <em>Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alias</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Entity#getAlias()
	 * @see #getEntity()
	 * @generated
	 */
	EAttribute getEntity_Alias();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dql.models.mapping.domain.Entity#getProbes <em>Probes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Probes</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Entity#getProbes()
	 * @see #getEntity()
	 * @generated
	 */
	EReference getEntity_Probes();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Probe <em>Probe</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Probe</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Probe
	 * @generated
	 */
	EClass getProbe();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.Probe#getMetricName <em>Metric Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Metric Name</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Probe#getMetricName()
	 * @see #getProbe()
	 * @generated
	 */
	EAttribute getProbe_MetricName();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.DecimalResult <em>Decimal Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Decimal Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DecimalResult
	 * @generated
	 */
	EClass getDecimalResult();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.DecimalResult#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DecimalResult#getValue()
	 * @see #getDecimalResult()
	 * @generated
	 */
	EAttribute getDecimalResult_Value();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.DecimalResult#getAccuracy <em>Accuracy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Accuracy</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DecimalResult#getAccuracy()
	 * @see #getDecimalResult()
	 * @generated
	 */
	EAttribute getDecimalResult_Accuracy();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Result <em>Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Result
	 * @generated
	 */
	EClass getResult();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.Result#getValid <em>Valid</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Valid</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Result#getValid()
	 * @see #getResult()
	 * @generated
	 */
	EAttribute getResult_Valid();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.DoF <em>Do F</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Do F</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DoF
	 * @generated
	 */
	EClass getDoF();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.DoF#getCurrentState <em>Current State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Current State</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DoF#getCurrentState()
	 * @see #getDoF()
	 * @generated
	 */
	EAttribute getDoF_CurrentState();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Aggregate <em>Aggregate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Aggregate</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Aggregate
	 * @generated
	 */
	EClass getAggregate();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.ExtendedEntity <em>Extended Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Extended Entity</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ExtendedEntity
	 * @generated
	 */
	EClass getExtendedEntity();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.ExtendedEntity#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Properties</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ExtendedEntity#getProperties()
	 * @see #getExtendedEntity()
	 * @generated
	 */
	EAttribute getExtendedEntity_Properties();

	/**
	 * Returns the meta object for data type '{@link java.util.Properties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Properties</em>'.
	 * @see java.util.Properties
	 * @model instanceClass="java.util.Properties"
	 * @generated
	 */
	EDataType getProperties();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	DomainFactory getDomainFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResourceImpl <em>Resource</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ResourceImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResource()
		 * @generated
		 */
		EClass RESOURCE = eINSTANCE.getResource();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ServiceImpl <em>Service</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ServiceImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getService()
		 * @generated
		 */
		EClass SERVICE = eINSTANCE.getService();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.EntityImpl <em>Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.EntityImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getEntity()
		 * @generated
		 */
		EClass ENTITY = eINSTANCE.getEntity();

		/**
		 * The meta object literal for the '<em><b>Identifier</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY__IDENTIFIER = eINSTANCE.getEntity_Identifier();

		/**
		 * The meta object literal for the '<em><b>Alias</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY__ALIAS = eINSTANCE.getEntity_Alias();

		/**
		 * The meta object literal for the '<em><b>Probes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY__PROBES = eINSTANCE.getEntity_Probes();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ProbeImpl <em>Probe</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ProbeImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getProbe()
		 * @generated
		 */
		EClass PROBE = eINSTANCE.getProbe();

		/**
		 * The meta object literal for the '<em><b>Metric Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROBE__METRIC_NAME = eINSTANCE.getProbe_MetricName();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.DecimalResultImpl <em>Decimal Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.DecimalResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDecimalResult()
		 * @generated
		 */
		EClass DECIMAL_RESULT = eINSTANCE.getDecimalResult();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DECIMAL_RESULT__VALUE = eINSTANCE.getDecimalResult_Value();

		/**
		 * The meta object literal for the '<em><b>Accuracy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DECIMAL_RESULT__ACCURACY = eINSTANCE.getDecimalResult_Accuracy();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResultImpl <em>Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResult()
		 * @generated
		 */
		EClass RESULT = eINSTANCE.getResult();

		/**
		 * The meta object literal for the '<em><b>Valid</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESULT__VALID = eINSTANCE.getResult_Valid();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.DoFImpl <em>Do F</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.DoFImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDoF()
		 * @generated
		 */
		EClass DO_F = eINSTANCE.getDoF();

		/**
		 * The meta object literal for the '<em><b>Current State</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DO_F__CURRENT_STATE = eINSTANCE.getDoF_CurrentState();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.AggregateImpl <em>Aggregate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.AggregateImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getAggregate()
		 * @generated
		 */
		EClass AGGREGATE = eINSTANCE.getAggregate();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ExtendedEntityImpl <em>Extended Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ExtendedEntityImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getExtendedEntity()
		 * @generated
		 */
		EClass EXTENDED_ENTITY = eINSTANCE.getExtendedEntity();

		/**
		 * The meta object literal for the '<em><b>Properties</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXTENDED_ENTITY__PROPERTIES = eINSTANCE.getExtendedEntity_Properties();

		/**
		 * The meta object literal for the '<em>Properties</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.util.Properties
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getProperties()
		 * @generated
		 */
		EDataType PROPERTIES = eINSTANCE.getProperties();

	}

} //DomainPackage
