/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.mapping;

import org.eclipse.emf.common.util.EList;

import tools.descartes.dql.models.mapping.domain.Aggregate;
import tools.descartes.dql.models.mapping.domain.DoF;
import tools.descartes.dql.models.mapping.domain.Resource;
import tools.descartes.dql.models.mapping.domain.Service;
import tools.descartes.dql.models.mapping.filter.Conjunction;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Entity Mapping</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getDoFModelLocation <em>Do FModel Location</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getFilter <em>Filter</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getAggregates <em>Aggregates</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getDoF <em>Do F</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getResources <em>Resources</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getServices <em>Services</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.models.mapping.mapping.MappingPackage#getEntityMapping()
 * @model
 * @generated
 */
public interface EntityMapping extends Mapping {
	/**
	 * Returns the value of the '<em><b>Do FModel Location</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Do FModel Location</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Do FModel Location</em>' attribute.
	 * @see #setDoFModelLocation(String)
	 * @see tools.descartes.dql.models.mapping.mapping.MappingPackage#getEntityMapping_DoFModelLocation()
	 * @model default=""
	 * @generated
	 */
	String getDoFModelLocation();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getDoFModelLocation <em>Do FModel Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Do FModel Location</em>' attribute.
	 * @see #getDoFModelLocation()
	 * @generated
	 */
	void setDoFModelLocation(String value);

	/**
	 * Returns the value of the '<em><b>Filter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Filter</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Filter</em>' reference.
	 * @see #setFilter(Conjunction)
	 * @see tools.descartes.dql.models.mapping.mapping.MappingPackage#getEntityMapping_Filter()
	 * @model
	 * @generated
	 */
	Conjunction getFilter();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.mapping.EntityMapping#getFilter <em>Filter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Filter</em>' reference.
	 * @see #getFilter()
	 * @generated
	 */
	void setFilter(Conjunction value);

	/**
	 * Returns the value of the '<em><b>Aggregates</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.mapping.domain.Aggregate}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Aggregates</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Aggregates</em>' containment reference list.
	 * @see tools.descartes.dql.models.mapping.mapping.MappingPackage#getEntityMapping_Aggregates()
	 * @model containment="true"
	 * @generated
	 */
	EList<Aggregate> getAggregates();

	/**
	 * Returns the value of the '<em><b>Do F</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.mapping.domain.DoF}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Do F</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Do F</em>' containment reference list.
	 * @see tools.descartes.dql.models.mapping.mapping.MappingPackage#getEntityMapping_DoF()
	 * @model containment="true"
	 * @generated
	 */
	EList<DoF> getDoF();

	/**
	 * Returns the value of the '<em><b>Resources</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.mapping.domain.Resource}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resources</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resources</em>' containment reference list.
	 * @see tools.descartes.dql.models.mapping.mapping.MappingPackage#getEntityMapping_Resources()
	 * @model containment="true"
	 * @generated
	 */
	EList<Resource> getResources();

	/**
	 * Returns the value of the '<em><b>Services</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.mapping.domain.Service}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Services</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Services</em>' containment reference list.
	 * @see tools.descartes.dql.models.mapping.mapping.MappingPackage#getEntityMapping_Services()
	 * @model containment="true"
	 * @generated
	 */
	EList<Service> getServices();

} // EntityMapping
