/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.mapping.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tools.descartes.dql.models.mapping.domain.Aggregate;
import tools.descartes.dql.models.mapping.domain.DoF;
import tools.descartes.dql.models.mapping.domain.Resource;
import tools.descartes.dql.models.mapping.domain.Service;
import tools.descartes.dql.models.mapping.filter.Conjunction;
import tools.descartes.dql.models.mapping.mapping.EntityMapping;
import tools.descartes.dql.models.mapping.mapping.MappingPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Entity Mapping</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl#getDoFModelLocation <em>Do FModel Location</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl#getFilter <em>Filter</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl#getAggregates <em>Aggregates</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl#getDoF <em>Do F</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl#getResources <em>Resources</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.mapping.impl.EntityMappingImpl#getServices <em>Services</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EntityMappingImpl extends MappingImpl implements EntityMapping {
	/**
	 * The default value of the '{@link #getDoFModelLocation() <em>Do FModel Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDoFModelLocation()
	 * @generated
	 * @ordered
	 */
	protected static final String DO_FMODEL_LOCATION_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getDoFModelLocation() <em>Do FModel Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDoFModelLocation()
	 * @generated
	 * @ordered
	 */
	protected String doFModelLocation = DO_FMODEL_LOCATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getFilter() <em>Filter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFilter()
	 * @generated
	 * @ordered
	 */
	protected Conjunction filter;

	/**
	 * The cached value of the '{@link #getAggregates() <em>Aggregates</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAggregates()
	 * @generated
	 * @ordered
	 */
	protected EList<Aggregate> aggregates;

	/**
	 * The cached value of the '{@link #getDoF() <em>Do F</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDoF()
	 * @generated
	 * @ordered
	 */
	protected EList<DoF> doF;

	/**
	 * The cached value of the '{@link #getResources() <em>Resources</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getResources()
	 * @generated
	 * @ordered
	 */
	protected EList<Resource> resources;

	/**
	 * The cached value of the '{@link #getServices() <em>Services</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getServices()
	 * @generated
	 * @ordered
	 */
	protected EList<Service> services;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EntityMappingImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MappingPackage.Literals.ENTITY_MAPPING;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDoFModelLocation() {
		return doFModelLocation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDoFModelLocation(String newDoFModelLocation) {
		String oldDoFModelLocation = doFModelLocation;
		doFModelLocation = newDoFModelLocation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MappingPackage.ENTITY_MAPPING__DO_FMODEL_LOCATION, oldDoFModelLocation, doFModelLocation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Conjunction getFilter() {
		if (filter != null && filter.eIsProxy()) {
			InternalEObject oldFilter = (InternalEObject)filter;
			filter = (Conjunction)eResolveProxy(oldFilter);
			if (filter != oldFilter) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MappingPackage.ENTITY_MAPPING__FILTER, oldFilter, filter));
			}
		}
		return filter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Conjunction basicGetFilter() {
		return filter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFilter(Conjunction newFilter) {
		Conjunction oldFilter = filter;
		filter = newFilter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MappingPackage.ENTITY_MAPPING__FILTER, oldFilter, filter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Aggregate> getAggregates() {
		if (aggregates == null) {
			aggregates = new EObjectContainmentEList<Aggregate>(Aggregate.class, this, MappingPackage.ENTITY_MAPPING__AGGREGATES);
		}
		return aggregates;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DoF> getDoF() {
		if (doF == null) {
			doF = new EObjectContainmentEList<DoF>(DoF.class, this, MappingPackage.ENTITY_MAPPING__DO_F);
		}
		return doF;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Resource> getResources() {
		if (resources == null) {
			resources = new EObjectContainmentEList<Resource>(Resource.class, this, MappingPackage.ENTITY_MAPPING__RESOURCES);
		}
		return resources;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Service> getServices() {
		if (services == null) {
			services = new EObjectContainmentEList<Service>(Service.class, this, MappingPackage.ENTITY_MAPPING__SERVICES);
		}
		return services;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MappingPackage.ENTITY_MAPPING__AGGREGATES:
				return ((InternalEList<?>)getAggregates()).basicRemove(otherEnd, msgs);
			case MappingPackage.ENTITY_MAPPING__DO_F:
				return ((InternalEList<?>)getDoF()).basicRemove(otherEnd, msgs);
			case MappingPackage.ENTITY_MAPPING__RESOURCES:
				return ((InternalEList<?>)getResources()).basicRemove(otherEnd, msgs);
			case MappingPackage.ENTITY_MAPPING__SERVICES:
				return ((InternalEList<?>)getServices()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MappingPackage.ENTITY_MAPPING__DO_FMODEL_LOCATION:
				return getDoFModelLocation();
			case MappingPackage.ENTITY_MAPPING__FILTER:
				if (resolve) return getFilter();
				return basicGetFilter();
			case MappingPackage.ENTITY_MAPPING__AGGREGATES:
				return getAggregates();
			case MappingPackage.ENTITY_MAPPING__DO_F:
				return getDoF();
			case MappingPackage.ENTITY_MAPPING__RESOURCES:
				return getResources();
			case MappingPackage.ENTITY_MAPPING__SERVICES:
				return getServices();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MappingPackage.ENTITY_MAPPING__DO_FMODEL_LOCATION:
				setDoFModelLocation((String)newValue);
				return;
			case MappingPackage.ENTITY_MAPPING__FILTER:
				setFilter((Conjunction)newValue);
				return;
			case MappingPackage.ENTITY_MAPPING__AGGREGATES:
				getAggregates().clear();
				getAggregates().addAll((Collection<? extends Aggregate>)newValue);
				return;
			case MappingPackage.ENTITY_MAPPING__DO_F:
				getDoF().clear();
				getDoF().addAll((Collection<? extends DoF>)newValue);
				return;
			case MappingPackage.ENTITY_MAPPING__RESOURCES:
				getResources().clear();
				getResources().addAll((Collection<? extends Resource>)newValue);
				return;
			case MappingPackage.ENTITY_MAPPING__SERVICES:
				getServices().clear();
				getServices().addAll((Collection<? extends Service>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MappingPackage.ENTITY_MAPPING__DO_FMODEL_LOCATION:
				setDoFModelLocation(DO_FMODEL_LOCATION_EDEFAULT);
				return;
			case MappingPackage.ENTITY_MAPPING__FILTER:
				setFilter((Conjunction)null);
				return;
			case MappingPackage.ENTITY_MAPPING__AGGREGATES:
				getAggregates().clear();
				return;
			case MappingPackage.ENTITY_MAPPING__DO_F:
				getDoF().clear();
				return;
			case MappingPackage.ENTITY_MAPPING__RESOURCES:
				getResources().clear();
				return;
			case MappingPackage.ENTITY_MAPPING__SERVICES:
				getServices().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MappingPackage.ENTITY_MAPPING__DO_FMODEL_LOCATION:
				return DO_FMODEL_LOCATION_EDEFAULT == null ? doFModelLocation != null : !DO_FMODEL_LOCATION_EDEFAULT.equals(doFModelLocation);
			case MappingPackage.ENTITY_MAPPING__FILTER:
				return filter != null;
			case MappingPackage.ENTITY_MAPPING__AGGREGATES:
				return aggregates != null && !aggregates.isEmpty();
			case MappingPackage.ENTITY_MAPPING__DO_F:
				return doF != null && !doF.isEmpty();
			case MappingPackage.ENTITY_MAPPING__RESOURCES:
				return resources != null && !resources.isEmpty();
			case MappingPackage.ENTITY_MAPPING__SERVICES:
				return services != null && !services.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (doFModelLocation: ");
		result.append(doFModelLocation);
		result.append(')');
		return result.toString();
	}

} //EntityMappingImpl
