package tools.descartes.dql.lang.examples.tests.select;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.runner.RunWith;

import tools.descartes.dql.lang.descartesQL.AbsoluteTimeClause;
import tools.descartes.dql.lang.descartesQL.ObserveBetweenClause;
import tools.descartes.dql.lang.descartesQL.ObserveClause;
import tools.descartes.dql.lang.descartesQL.RelativeTimeClause;
import tools.descartes.dql.lang.descartesQL.RelativeTimeSignType;
import tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause;
import tools.descartes.dql.lang.descartesQL.TimeModifierType;
import tools.descartes.dql.lang.examples.tests.AbstractSelectQueryTest;
import tools.descartes.dql.lang.tests.DescartesQLInjectorProvider;

@RunWith(XtextRunner.class)
@InjectWith(DescartesQLInjectorProvider.class)
public class BasicQueryObserve2 extends AbstractSelectQueryTest {

	@Override
	public boolean expectConstraint() {
		return false;
	}

	@Override
	public boolean expectDoF() {
		return false;
	}

	@Override
	@Before
	public void initializeTest() throws Exception {
		super.initialize(createFileName(SELECT, this.getClass().getSimpleName()));
	}

	@Override
	public void testObserveClauseImpl(final ObserveClause observeClause) {
		final ObserveBetweenClause observation = (ObserveBetweenClause) observeClause.getObservation();
		assertNotNull(observation);

		final AbsoluteTimeClause startingTime = (AbsoluteTimeClause) observation.getStartingTime();
		assertNotNull(startingTime);
		assertEquals("2012-01-01T10:00", startingTime.getTimeSpec());

		final RelativeTimeWithSignClause endingTime = (RelativeTimeWithSignClause) observation.getEndingTime();
		assertNotNull(endingTime);

		final RelativeTimeSignType sign = endingTime.getSign();
		assertNotNull(sign);
		assertEquals("-", sign.getLiteral());

		final RelativeTimeClause timeClause = endingTime.getTimeClause();
		assertNotNull(timeClause);

		testRelativeTimeDuration(timeClause.getDurationClause(), new int[] { 3, 2, 4 }, new TimeModifierType[] {
				TimeModifierType.MONTH, TimeModifierType.DAY, TimeModifierType.HOUR });
	}

}
