package tools.descartes.dql.lang.examples.tests.select;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.eclipse.emf.common.util.EList;
import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.runner.RunWith;

import tools.descartes.dql.lang.descartesQL.ObserveClause;
import tools.descartes.dql.lang.descartesQL.ObserveRelativeClause;
import tools.descartes.dql.lang.descartesQL.ObserveRelativeDirectionType;
import tools.descartes.dql.lang.descartesQL.RelativeTimeClause;
import tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause;
import tools.descartes.dql.lang.descartesQL.SampleClause;
import tools.descartes.dql.lang.descartesQL.TimeModifierType;
import tools.descartes.dql.lang.examples.tests.AbstractSelectQueryTest;
import tools.descartes.dql.lang.tests.DescartesQLInjectorProvider;

@RunWith(XtextRunner.class)
@InjectWith(DescartesQLInjectorProvider.class)
public class BasicQueryObserve4 extends AbstractSelectQueryTest {

	@Override
	public boolean expectConstraint() {
		return false;
	}

	@Override
	public boolean expectDoF() {
		return false;
	}

	@Override
	@Before
	public void initializeTest() throws Exception {
		super.initialize(createFileName(SELECT, this.getClass().getSimpleName()));
	}

	@Override
	public void testObserveClauseImpl(final ObserveClause observeClause) {
		final ObserveRelativeClause observation = (ObserveRelativeClause) observeClause.getObservation();
		assertNotNull(observation);

		final ObserveRelativeDirectionType direction = observation.getDirection();
		assertNotNull(direction);
		assertEquals(ObserveRelativeDirectionType.NEXT, direction);

		final RelativeTimeClause timeTarget = (RelativeTimeClause) observation.getTimeTarget();
		assertNotNull(timeTarget);

		EList<RelativeTimeDurationClause> durationClause = timeTarget.getDurationClause();
		assertNotNull(durationClause);
		assertEquals(1, durationClause.size());

		testRelativeTimeDuration(durationClause, new int[] { 3 }, new TimeModifierType[] { TimeModifierType.HOUR });

		final SampleClause sample = observeClause.getSampleClause();
		assertNotNull(sample);

		durationClause = sample.getDurationClause();
		assertEquals(1, durationClause.size());

		testRelativeTimeDuration(durationClause, new int[] { 15 }, new TimeModifierType[] { TimeModifierType.MINUTE });
	}
}
