/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.vizualization.observations;

import java.util.Date;

public class ObservationSpecification {
	private Date start = null;
	private Date end = null;
	private Date aggregateBy = null;
	private boolean valid = false;

	public ObservationSpecification() {
		super();
	}

	public ObservationSpecification(final Date start, final Date end) {
		super();

		this.start = start;
		this.end = end;
	}

	public ObservationSpecification(final Date start, final Date end, final Date aggregateBy) {
		super();

		this.start = start;
		this.end = end;
		this.aggregateBy = aggregateBy;
	}

	public Date getAggregateBy() {
		return aggregateBy;
	}

	public Date getEnd() {
		return end;
	}

	public Date getStart() {
		return start;
	}

	public boolean hasAggregateBy() {
		return aggregateBy != null ? true : false;
	}

	public boolean isValid() {
		return valid;
	}

	public void setAggregateBy(final Date aggregateBy) {
		this.aggregateBy = aggregateBy;
	}

	public void setEnd(final Date end) {
		this.end = end;
	}

	public void setStart(final Date start) {
		this.start = start;
	}

	public void setValid(final boolean valid) {
		this.valid = valid;
	}
}
